//
//  gameView.h
//  CocoaBornes
//
//  Created by Robert Ziefel on Wed Oct 23 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "myWindow.h"

@interface gameView : NSView {

    int otherMouseButtonDownCounter; // this makes it so I get a different silly message
    // every time, a la Warcraft

    NSTextView *statusText, *myProgressText, *opponentProgressText;
    // where, of course, "my" doesn't mean the computer, it means you. Your opponent is the computer


    NSTrackingRectTag trackingRectCard[16];

    int state;
    int emptyCardsPlayed;
    int scoreAnyway;
    int whoGoesFirst;
    int clickNumber, clickedCard, numberOfClicks;
    int numberOf25s, numberOf50s, numberOf75s, numberOf100s, numberOf200s, numberOfSafetys;
    int numberOf25sO, numberOf50sO, numberOf75sO, numberOf100sO, numberOf200sO, numberOfSafetysO; // these are the computers
    int currentDistance, currentDistanceGoal, opponentDistance, extensionByMe, extensionByOpponent;

    int coupFourre, coupFourreO, endScore, endScoreO, gamesWon, gamesWonO, handScore, handScoreO;

    int clickCardTransparency, transparencyDirection;
    
    NSTimer *theTimer;
    NSImage *cardBack;
    NSImage *cardbackToDeal;
    NSImage *playingArea; // this is the size of the board, and is what gets drawn to (an offscreen, if you will)
	NSMutableArray *cards;
    NSMutableArray *cardsInPlay; // there are 27 of these, and the numbers match up to the rectangles
    NSPoint cardSlots[28];

    NSSound *comeon, *dealCard, *getSpecial, *cheers, *extendsRound, *extendQuestion, *shift, *shuffle;

    BOOL askedToExtend; // don't ask twice in one game!
    BOOL gotSpecialBool; // just for the sound. I don't want too sounds to play, after all
    BOOL opponentPlayedSpecial; // darn it, if == YES I'll have to give them another turn!
    BOOL playSounds;

    IBOutlet NSMenuItem *soundMenu;
    IBOutlet NSMenuItem *oneClickMenu;
    IBOutlet NSMenuItem *newHandMenu;
}

- (IBAction)soundMenuAction:(id)sender;
- (IBAction)oneClickMenuAction:(id)sender;
- (IBAction)newHandMenuAction:(id)sender;
- (id) initWithFrame :(NSRect)frameRect;
- (void)dealloc;
- (void)drawRect:(NSRect)rect;
- (void)mouseEntered:(NSEvent *)theEvent;
- (void)mouseExited:(NSEvent *)theEvent;
- (void)mouseUp:(NSEvent *)event;
- (void)rightMouseUp:(NSEvent *)theEvent;
- (void)otherMouseDown:(NSEvent *)theEvent;

- (void)timerFired:(id)timer;
- (void)setTimer:(double)interval;
- (void)stopTimer;

- (void)playCardAt :(int)cardAt;
- (void)refreshDeck;
- (void) finalScoreAndReset;
- (void) deleteCard;
- (void) computersTurn;
- (void) computerDiscard;
@end
