//
//  gameView.m
//  CocoaBornes
//
//  Created by Robert Ziefel on Wed Oct 23 2002.
//  Copyright (c) 2002 Silverstreak Software. All rights reserved.
//

// todo
// more animations?
// make the computer smarter about the end- like if he's looking for a 50 but he gets a 25, he hold onto it for a couple rounds?
// also, I once saw him throw away two blue cards at the very end, just because no-one was 50 away from the finish...


#import "gameView.h"

#define noCardsDelt 0
#define initalCardsDelt 1
#define playing 2
#define humanGoesFirst 0
#define computerGoesFirst 1

@implementation gameView

inline float	randBetween( float x, float y )
{
    float	s;

    s = (float)(random() % 123456789) / 123456789.0;
    s *= fabs( x - y );
    s += (x > y) ? y : x;

    return s;
}

- (id) initWithFrame :(NSRect)frameRect
{
    [super initWithFrame: frameRect];

    otherMouseButtonDownCounter = 0;
    clickCardTransparency = 100;
    transparencyDirection = -20;
    clickNumber = 0;
    numberOf25s = 0;
    numberOf50s = 0;
    numberOf75s = 0;
    numberOf100s = 0;
    numberOf200s = 0;
    numberOf25sO = 0;
    numberOf50sO = 0;
    numberOf75sO = 0;
    numberOf100sO = 0;
    numberOf200sO = 0;
    extensionByMe = 0;
    scoreAnyway = 0; // this is when you don't complete the race, but should get points anyway
    emptyCardsPlayed = 0;
    extensionByOpponent = 0;
    numberOfClicks = 2;
    currentDistanceGoal = 700;
    coupFourre = 0;
    coupFourreO = 0;
    currentDistance = 0;
    opponentDistance = 0;
    numberOfSafetys = 0;
    numberOfSafetysO = 0;
    askedToExtend = NO;
    gotSpecialBool = NO;
    opponentPlayedSpecial = NO;
    whoGoesFirst = humanGoesFirst;
	dealCard = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"dealcard" ofType:@"aif"] byReference: YES];
    comeon = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"comeon" ofType:@"aif"] byReference: YES];
    getSpecial = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"getspecial" ofType:@"aif"] byReference: YES];
    cheers = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"cheers" ofType:@"aif"] byReference: YES];
    extendsRound = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"extendsround" ofType:@"aif"] byReference: YES];
    extendQuestion = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"extendquestion" ofType:@"aif"] byReference: YES];
    shift = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"shift" ofType:@"aif"] byReference: YES];
    shuffle  = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"shuffle" ofType:@"aif"] byReference: YES];

    statusText = [[NSTextView allocWithZone:[self zone]] initWithFrame:NSMakeRect(145, 5, 447, 21)];
    myProgressText = [[NSTextView allocWithZone:[self zone]] initWithFrame:NSMakeRect(97, 565, 47, 15)];
    opponentProgressText = [[NSTextView allocWithZone:[self zone]] initWithFrame:NSMakeRect(95, 494, 47, 15)];

    [statusText setEditable :NO];
    [self addSubview:statusText];
    [myProgressText setEditable :NO];
    [self addSubview:myProgressText];
    [opponentProgressText setEditable :NO];
    [self addSubview:opponentProgressText];

    [statusText setAlignment :NSCenterTextAlignment];
    state = noCardsDelt;
    playingArea = [[NSImage allocWithZone:[self zone]] initWithSize: NSMakeSize(800, 600)];
    cardbackToDeal = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"cardbackToDeal" ofType:@"tiff"]];
    if ( ![cardbackToDeal isValid] )
        return nil;
    cardBack = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"cardback" ofType:@"tiff"]];
    srandom( time( 0 ) );
    if ( ![cardBack isValid] )
        return nil;

    [self setTimer :.3];
    return self;
}

- (void)dealloc
{
    [cardsInPlay removeAllObjects];
    [cards removeAllObjects];
    [comeon dealloc];
    [dealCard dealloc];
    [getSpecial dealloc];
    [cheers dealloc];
    [extendsRound dealloc];
    [extendQuestion dealloc];
    [shift dealloc];
    [shuffle dealloc];
	[super dealloc];
}

- (IBAction)soundMenuAction:(id)sender
{
    
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    if ( playSounds == YES )
        [soundMenu setState :NSOffState]; // I want to reverse it when it's clicked
    else
        [soundMenu setState :NSOnState];
    
    if ( [soundMenu state] == NSOnState ){
        [defaults setObject:@"YES" forKey:@"playSounds"];
        playSounds = YES;
        [statusText setString :NSLocalizedStringFromTable(@"soundOn", @"localizedStrings", @"This is the sound on string")];

    }
    else {
        [defaults setObject:@"NO" forKey:@"playSounds"];
        playSounds = NO;
        [statusText setString :NSLocalizedStringFromTable(@"soundOff", @"localizedStrings", @"This is the sound off string")];

    }
    
    [defaults synchronize];
     
}

- (IBAction)oneClickMenuAction:(id)sender
{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    if ( numberOfClicks == 1 )
        [oneClickMenu setState :NSOffState]; // I want to reverse it when it's clicked
    else
        [oneClickMenu setState :NSOnState];

    if ( [oneClickMenu state] == NSOnState ){
        [defaults setInteger:1 forKey:@"numberOfClicks"];
        numberOfClicks = 1;
        [statusText setString :NSLocalizedStringFromTable(@"oneClickOn", @"localizedStrings", @"This is the one click on string")];
    }
    else {
        [defaults setInteger:2 forKey:@"numberOfClicks"];
        numberOfClicks = 2;
        [statusText setString :NSLocalizedStringFromTable(@"oneClickOff", @"localizedStrings", @"This is the one click off string")];

    }

    [defaults synchronize];    
}

- (IBAction)newHandMenuAction:(id)sender
{
    [self finalScoreAndReset];
}

- (void)drawRect:(NSRect)rect
{
    int lcv;
    NSMutableDictionary *fontAtributes = [NSMutableDictionary dictionary];
    [fontAtributes setObject:[NSFont fontWithName:@"Helvetica" size:24.0] forKey:NSFontAttributeName];
    [fontAtributes setObject:[NSColor whiteColor] forKey:NSForegroundColorAttributeName];
    [playingArea lockFocus];
    
    if (state == noCardsDelt){
        [cardbackToDeal compositeToPoint:NSMakePoint(618, 14)
                    fromRect:NSMakeRect(0, 0, 80, 100)
                    operation:NSCompositeSourceOver];
    }
    if ( state == playing ){
        for ( lcv = 0; lcv < 28; lcv++ ){
            if ( lcv == 7 )
                continue; // 7 is special. It's "empty" but still keeps its backing
            if ( lcv > 20 ){
                if ( ![[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Name"] isEqualTo :@"empty"] ) {
                    // we have to show only backs for our opponent. No cheating!
                    [cardBack compositeToPoint:cardSlots[lcv]
                                  fromRect:NSMakeRect(0, 0, 80, 100)
                                 operation:NSCompositeSourceOver];
                }
                else {
                    [[NSColor clearColor] set];
                    NSRectFill( NSMakeRect (cardSlots[lcv].x, cardSlots[lcv].y, 80, 100));
                }
            }
            else {
                if ( ![[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Name"] isEqualTo :@"empty"] ) {
                    [[NSImage imageNamed:[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Name"]] compositeToPoint:cardSlots[lcv] fromRect:NSMakeRect(0, 0, 80, 100) operation:NSCompositeSourceOver];
                }
                else { // we have to cover it, or it'll just stay there, even
                    // though it should be covered by the "empty" card
                    [[NSColor clearColor] set];
                    NSRectFill( NSMakeRect (cardSlots[lcv].x, cardSlots[lcv].y, 80, 100 ));
                }
            }
        }
        [self refreshDeck]; // if I don't do this, sometimes I get an array bounds error, as I try to use 0, which doesn't exist
        // technically this is a work around, as every time I take a card I should call this, but hey, "it works"!!!!
        if ( [[[cards objectAtIndex: 0] objectForKey :@"Name"] isEqualTo :@"empty"] ){
            [[NSColor clearColor] set];
            NSRectFill( NSMakeRect (618, 14, 80, 100) );
        }
    }        
    [playingArea unlockFocus];
    [self lockFocus];
    [playingArea compositeToPoint:NSMakePoint(0, 0)
                      fromRect:NSMakeRect(0, 0, 800, 600)
                     operation:NSCompositeSourceOver];
    if ( [cards count] > 0 ) // because I may not yet have any cards....
        if ( ![[[cards objectAtIndex: 0] objectForKey :@"Name"] isEqualTo :@"empty"] )
            [[NSString stringWithFormat:@"%d", [cards count]] drawAtPoint:NSMakePoint(642, 54) withAttributes:fontAtributes];

    [self unlockFocus];
    
}

- (void)mouseEntered:(NSEvent *)theEvent
{
    clickNumber = 0;
    clickedCard = [[theEvent userData] intValue];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"greenlight"] )
        [statusText setString :NSLocalizedStringFromTable(@"greenlight", @"localizedStrings", @"This is the green light string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"redlight"] )
        [statusText setString :NSLocalizedStringFromTable(@"redlight", @"localizedStrings", @"This is the red light string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"flat tire"] )
        [statusText setString :NSLocalizedStringFromTable(@"flattire", @"localizedStrings", @"This is the flat tire string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"sparetire"] )
        [statusText setString :NSLocalizedStringFromTable(@"sparetire", @"localizedStrings", @"This is the spare tire string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"nogas"] )
        [statusText setString :NSLocalizedStringFromTable(@"nogas", @"localizedStrings", @"This is the no gas string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"gasstation"] )
        [statusText setString :NSLocalizedStringFromTable(@"gasstation", @"localizedStrings", @"This is the gas station string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"speedlimit"] )
        [statusText setString :NSLocalizedStringFromTable(@"speedlimit", @"localizedStrings", @"This is the speed limit string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"endspeedlimit"] )
        [statusText setString :NSLocalizedStringFromTable(@"endspeedlimit", @"localizedStrings", @"This is the end speed limit string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"accident"] )
        [statusText setString :NSLocalizedStringFromTable(@"accident", @"localizedStrings", @"This is the accident string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"mechanic"] )
        [statusText setString :NSLocalizedStringFromTable(@"mechanic", @"localizedStrings", @"This is the mechanic string")];
    
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"driveaircar"] )
        [statusText setString :NSLocalizedStringFromTable(@"driveaircar", @"localizedStrings", @"This is the driveaircar string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"driveambulance"] )
        [statusText setString :NSLocalizedStringFromTable(@"driveambulance", @"localizedStrings", @"This is the drive ambulance string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"gascan"] )
        [statusText setString :NSLocalizedStringFromTable(@"gascan", @"localizedStrings", @"This is the gas can string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"racecartraining"] )
        [statusText setString :NSLocalizedStringFromTable(@"racecartraining", @"localizedStrings", @"This is the race car training string")];

    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"200miles"] )
        [statusText setString :NSLocalizedStringFromTable(@"200miles", @"localizedStrings", @"This is the 200miles string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"100miles"] )
        [statusText setString :NSLocalizedStringFromTable(@"100miles", @"localizedStrings", @"This is the 100miles string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"75miles"] )
        [statusText setString :NSLocalizedStringFromTable(@"75miles", @"localizedStrings", @"This is the 75miles string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"50miles"] )
        [statusText setString :NSLocalizedStringFromTable(@"50miles", @"localizedStrings", @"This is the 50miles string")];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"25miles"] )
        [statusText setString :NSLocalizedStringFromTable(@"25miles", @"localizedStrings", @"This is the 25miles string")];
}


- (void)mouseExited:(NSEvent *)theEvent
{
    [statusText setString :@" "]; // clear this out, as that looks a little better.
    //clickedCard = -1; // !!!!! the problem is, without this, I can leave a card, click some random loc, and have it work
    // but how do I guard against the race condition where this happens first!!!!
}



- (void)rightMouseUp:(NSEvent *)theEvent
{
    [self deleteCard];
}

- (void)mouseUp:(NSEvent *)event
{
    NSPoint tempPos;
    NSRect tempRect;
    int lcv; // used for randomizing the cards
    //    NSLog(@"there are %d cards played when the mouse went down, and state was %d", cardsPlayed, state);
    // check each card out on the "table"

    if ( [event modifierFlags] & NSControlKeyMask ){ // if they hold the control key, delete the card
        [self deleteCard];
        return;
    }
    if ( [event modifierFlags] & NSCommandKeyMask ) // if they hold the option key, try to play the card
        clickNumber += 1;
    
    if ( [event modifierFlags] & NSShiftKeyMask ) // if they hold the option key, try to play the card
        NSLog ([cardsInPlay description]); // I'll leave this in as an easter egg
    
    if ( state == playing )
        clickNumber += 1;

    tempPos = [self convertPoint:[event locationInWindow] fromView:nil];
    tempRect = NSMakeRect( tempPos.x, tempPos.y, 1, 1 );

    if ( NSIntersectsRect ( tempRect, NSMakeRect(618, 14, 80, 100) ) && state == noCardsDelt ){
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        numberOfClicks = [defaults integerForKey :@"numberOfClicks"]; // read preference for this !!!!!
        if ( numberOfClicks == 0 ) // first time playing
            numberOfClicks = 2;
        if ( numberOfClicks == 2 ) // first time playing
            [oneClickMenu setState :NSOffState];
        else
            [oneClickMenu setState :NSOnState];
        
        if ( [[defaults objectForKey :@"playSounds"] isEqualTo: @"YES"] ){
            playSounds = YES;
            [soundMenu setState :NSOnState];
        }
        else if ( [[defaults objectForKey :@"playSounds"] isEqualTo: @"NO"] ) {
            playSounds = NO;
            [soundMenu setState :NSOffState];
        }
        else { // it's the first time I'm playing, so you better believe you're getting sound!
            playSounds = YES;
            [soundMenu setState :NSOnState];
            [defaults setObject:@"YES" forKey:@"playSounds"];
        }
        
        // also I have to do this here because I can't do it in the init routine, for whatever reason.
        if ( playSounds )
            [comeon play];
        trackingRectCard[1] = [self addTrackingRect: NSMakeRect(17, 31, 80, 100) owner: self userData:@"0" assumeInside:NO ];
        cardSlots[0] = NSMakePoint(17, 31);
        trackingRectCard[2] = [self addTrackingRect: NSMakeRect(99, 31, 80, 100) owner: self userData:@"1" assumeInside:NO ];
        cardSlots[1] = NSMakePoint(99, 31);
        trackingRectCard[3] = [self addTrackingRect: NSMakeRect(180, 31, 80, 100) owner: self userData:@"2" assumeInside:NO ];
        cardSlots[2] = NSMakePoint(180, 31);
        trackingRectCard[4] = [self addTrackingRect: NSMakeRect(263, 31, 80, 100) owner: self userData:@"3" assumeInside:NO ];
        cardSlots[3] = NSMakePoint(263, 31);
        trackingRectCard[5] = [self addTrackingRect: NSMakeRect(345, 31, 80, 100) owner: self userData:@"4" assumeInside:NO ];
        cardSlots[4] = NSMakePoint(345, 31);
        trackingRectCard[6] = [self addTrackingRect: NSMakeRect(427, 31, 80, 100) owner: self userData:@"5" assumeInside:NO ];
        cardSlots[5] = NSMakePoint(427, 31);
        trackingRectCard[7] = [self addTrackingRect: NSMakeRect(510, 31, 80, 100) owner: self userData:@"6" assumeInside:NO ];
        cardSlots[6] = NSMakePoint(510, 31);

        cardSlots[7] = NSMakePoint(618, 14);

        trackingRectCard[0] = [self addTrackingRect: NSMakeRect(699, 14, 80, 100) owner: self userData:@"8" assumeInside:YES ];
        cardSlots[8] = NSMakePoint(699, 14);
        
        trackingRectCard[8] = [self addTrackingRect: NSMakeRect(287, 153, 80, 100) owner: self userData:@"9" assumeInside:NO ];
        cardSlots[9] = NSMakePoint(287, 153);
        trackingRectCard[13] = [self addTrackingRect: NSMakeRect(693, 143, 80, 100) owner: self userData:@"10" assumeInside:NO ];
        cardSlots[10] = NSMakePoint(693, 143);
        
        trackingRectCard[9] = [self addTrackingRect: NSMakeRect(288, 252, 80, 100) owner: self userData:@"11" assumeInside:NO ];
        cardSlots[11] = NSMakePoint(288, 253);
        trackingRectCard[15] = [self addTrackingRect: NSMakeRect(694, 244, 80, 100) owner: self userData:@"12" assumeInside:NO ];
        cardSlots[12] = NSMakePoint(694, 244);
        
        trackingRectCard[10] = [self addTrackingRect: NSMakeRect(26, 362, 80, 100) owner: self userData:@"13" assumeInside:NO ];
        cardSlots[13] = NSMakePoint(26, 363);
        trackingRectCard[11] = [self addTrackingRect: NSMakeRect(113, 362, 80, 100) owner: self userData:@"14" assumeInside:NO ];
        cardSlots[14] = NSMakePoint(114, 363);
        trackingRectCard[12] = [self addTrackingRect: NSMakeRect(201, 362, 80, 100) owner: self userData:@"15" assumeInside:NO ];
        cardSlots[15] = NSMakePoint(202, 363);
        trackingRectCard[13] = [self addTrackingRect: NSMakeRect(289, 362, 80, 100) owner: self userData:@"16" assumeInside:NO ];
        cardSlots[16] = NSMakePoint(290, 363);
        
        cardSlots[17] = NSMakePoint(430, 353);
        cardSlots[18] = NSMakePoint(518, 353);
        cardSlots[19] = NSMakePoint(607, 353);
        cardSlots[20] = NSMakePoint(693, 353);
        
        cardSlots[21] = NSMakePoint(214, 485);
        cardSlots[22] = NSMakePoint(296, 485);
        cardSlots[23] = NSMakePoint(378, 485);
        cardSlots[24] = NSMakePoint(462, 485);
        cardSlots[25] = NSMakePoint(544, 485);
        cardSlots[26] = NSMakePoint(627, 485);
        cardSlots[27] = NSMakePoint(708, 485);
        state = initalCardsDelt;
        clickCardTransparency = 0;
        transparencyDirection = 20;

        cards = [NSMutableArray arrayWithContentsOfFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"cardlist" ofType:@"strings"]];
        // this empty card is used whenever there's a hole that need to be filled in

        cardsInPlay = [NSMutableArray arrayWithCapacity: 28];
        [cards retain];
        [cardsInPlay retain];
//        NSLog (@"%d", [cards count]);
        for ( lcv = 0; lcv < [cards count]; lcv++ ){
            int x = randBetween (1, [cards count] );
            if ( x != lcv )
                [cards exchangeObjectAtIndex: lcv withObjectAtIndex:x];
        }

        for ( lcv = 0; lcv < 28; lcv++ ){
            NSMutableDictionary *nextEmptyCard = [NSMutableDictionary dictionaryWithCapacity: 2];
            [nextEmptyCard setObject:@"empty" forKey:@"Name"];
            [nextEmptyCard setObject:@"0" forKey:@"Number"];
            [cardsInPlay addObject :nextEmptyCard]; // first, put in empty cards so we fill the spaces up
        }
        
        for ( lcv = 0; lcv < 7; lcv++ ) { // now, give the first hand of cards out
            [cardsInPlay replaceObjectAtIndex :lcv withObject:[cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
            [cardsInPlay replaceObjectAtIndex :lcv + 21 withObject:[cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
        }
        [playingArea lockFocus];
        for ( lcv = 0; lcv < 28; lcv++ ){
            if ( lcv > 20 )
                [cardBack compositeToPoint:cardSlots[lcv]
                            fromRect:NSMakeRect(0, 0, 80, 100)
                            operation:NSCompositeSourceOver];
            
            else
            [[NSImage imageNamed:[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Name"]] compositeToPoint:cardSlots[lcv]
                            fromRect:NSMakeRect(0, 0, 80, 100)
                             operation:NSCompositeSourceOver];
        }
        [cardBack compositeToPoint:cardSlots[7]
                          fromRect:NSMakeRect(0, 0, 80, 100)
                         operation:NSCompositeSourceOver];
        [playingArea unlockFocus];
//        NSLog ([cardsInPlay description]);
        if (whoGoesFirst == computerGoesFirst ){
            [self computersTurn];
            whoGoesFirst = humanGoesFirst;
        }
        else
            whoGoesFirst = computerGoesFirst; //this alternates who has the first turn
        return;
    }
    if ( state == playing ){
        // if quickClick is on, this 2 will become a 1 !!!!!
        if (clickNumber >= numberOfClicks && clickedCard < 7 && clickedCard > -1 ){
            [self playCardAt :clickedCard]; // this of course checks to see if I can play it and then does if I can
            [self refreshDeck];
            clickNumber = 0;
        }
    }

    if ( !gotSpecialBool ){ // don't bother playing another sound
        if ( [dealCard isPlaying] ) // however, play all of these, so wait until it's done
            [NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:.5]];
    } else
        gotSpecialBool = NO;
    
}

- (void)otherMouseDown:(NSEvent *)theEvent
{
    if ( otherMouseButtonDownCounter == 0 )
        [statusText setString :NSLocalizedStringFromTable(@"first", @"localizedStrings", @"This is the first middle mouse button string")];
    if ( otherMouseButtonDownCounter == 1 )
        [statusText setString :NSLocalizedStringFromTable(@"second", @"localizedStrings", @"This is the second middle mouse button string")];
    if ( otherMouseButtonDownCounter == 2 )
        [statusText setString :NSLocalizedStringFromTable(@"third", @"localizedStrings", @"This is the third middle mouse button string")];
    if ( otherMouseButtonDownCounter == 3 )
        [statusText setString :NSLocalizedStringFromTable(@"forth", @"localizedStrings", @"This is the forth middle mouse button string")];
    if ( otherMouseButtonDownCounter == 4 )
        [statusText setString :NSLocalizedStringFromTable(@"fifth", @"localizedStrings", @"This is the fifth middle mouse button string")];
    if ( otherMouseButtonDownCounter == 5 )
        [statusText setString :NSLocalizedStringFromTable(@"sixth", @"localizedStrings", @"This is the sixth middle mouse button string")];
    if ( otherMouseButtonDownCounter == 6 )
        [statusText setString :NSLocalizedStringFromTable(@"seventh", @"localizedStrings", @"This is the seventh middle mouse button string")];
    if ( otherMouseButtonDownCounter == 7 )
        [statusText setString :NSLocalizedStringFromTable(@"eighth", @"localizedStrings", @"This is the eighth middle mouse button string")];
    if ( otherMouseButtonDownCounter == 8 )
        [statusText setString :NSLocalizedStringFromTable(@"ninth", @"localizedStrings", @"This is the ninth middle mouse button string")];
    if ( otherMouseButtonDownCounter == 9 )
        [statusText setString :NSLocalizedStringFromTable(@"tenth", @"localizedStrings", @"This is the tenth middle mouse button string")];
    if ( otherMouseButtonDownCounter == 10 )
        [statusText setString :@" "];

    
    otherMouseButtonDownCounter++;
    if ( otherMouseButtonDownCounter > 10 )
        otherMouseButtonDownCounter = 0;
}

- (void)setTimer:(double)interval
{
    NSTimer	*aTimer;

    aTimer = [NSTimer	scheduledTimerWithTimeInterval:interval
                                              target:self
                                            selector:@selector(timerFired:)
                                            userInfo:nil
                                             repeats:YES];
    if (theTimer) {
        [theTimer invalidate];
        [theTimer release];
        theTimer = nil;
    }
    theTimer = [aTimer retain];
}


//-------------------------------------------------------------
//  stop the timer
//-------------------------------------------------------------
- (void)stopTimer
{
    if (theTimer) {
        [theTimer invalidate];
        [theTimer release];
        theTimer = nil;
    }
}


//-------------------------------------------------------------
//  timer event
//-------------------------------------------------------------
- (void)timerFired:(id)timer
{
    if (state == noCardsDelt){
        clickCardTransparency += transparencyDirection;
        if ( clickCardTransparency > 91 || clickCardTransparency < 9)
            transparencyDirection *= -1;
        
        [self lockFocus];
        [cardBack compositeToPoint:NSMakePoint(618, 14)
                        fromRect:NSMakeRect(0, 0, 80, 100)
                        operation:NSCompositeSourceOver];
        
        [cardbackToDeal drawAtPoint:NSMakePoint(618, 14)
                        fromRect:NSMakeRect(0, 0, 80, 100)
                        operation:NSCompositeSourceOver
                        fraction:clickCardTransparency * .01];
        [self unlockFocus];
        [[self window] flushWindow];
        return;
    }
    if ( state == initalCardsDelt && clickCardTransparency <= 100){
        clickCardTransparency += transparencyDirection;

        [self lockFocus];
        [playingArea drawAtPoint:NSMakePoint(0, 0)
                           fromRect:NSMakeRect(0, 0, 800, 600)
                          operation:NSCompositeSourceOver
                           fraction:clickCardTransparency * .01];
        [self unlockFocus];
        [[self window] flushWindow];
        return;
    }

    if ( state == initalCardsDelt && clickCardTransparency >= 100){
        state = playing;
        [self stopTimer];
        [self setNeedsDisplay :YES];
    }
}

- (void)playCardAt :(int)cardAt
{

    [statusText setString :@" "];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"empty"] )
        return;

    if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"greenlight"] ){
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"greenlight"] ){
            [statusText setString :NSLocalizedStringFromTable(@"alreadyGreen", @"localizedStrings", @"This is the message for already having a green light")];
            return;
        }
        if ( ![[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"redlight"] && [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Number"] intValue] <= -1) {
//            NSLog (@"%d", [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Number"] intValue]);
            // I don't have a redlight, but rather another nasty below 0 that a green light can't fix
            [statusText setString :NSLocalizedStringFromTable(@"onlyred", @"localizedStrings", @"This is the message that only red light is fixed by a green light")];
            return;
        }
        // If I've gotten this far, I can play the card
		
        [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardAt]];
//        NSLog ([[cards objectAtIndex :0] description]);
        [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
    }
    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"driveaircar"] ){
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"flat tire"] ){
            // if they are currently waiting for a spare, we give them a green light at this point
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 11 withObject: newGreenLight];
            if ( playSounds )
                [cheers play];
            coupFourre++;
        }
        if ( playSounds )
            [getSpecial play];
        gotSpecialBool = YES;
        numberOfSafetys++;
        [cardsInPlay replaceObjectAtIndex: 13 withObject: [cardsInPlay objectAtIndex :cardAt]];
        [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
            
    }            
    
    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"driveambulance"] ){
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"redlight"] || [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"empty"]){
            // if they are currently waiting for a spare, we give them a green light at this point
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 11 withObject: newGreenLight];
            if ( playSounds )
                [cheers play];
            coupFourre++;
        }
        if ( [[[cardsInPlay objectAtIndex: 9] objectForKey :@"Name"] isEqualTo :@"speedlimit"] ){
            // if they are currently waiting for "no limit" card, we give them one at this point
            NSMutableDictionary *noSpeedLimit = [NSMutableDictionary dictionaryWithCapacity: 2];
            [noSpeedLimit setObject:@"endspeedlimit" forKey:@"Name"];
            [noSpeedLimit setObject:@"5" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 9 withObject: noSpeedLimit];
            coupFourre++;
            if ( playSounds )
                [cheers play];
        }
        if ( playSounds )
            [getSpecial play];
        numberOfSafetys++;
        gotSpecialBool = YES;
        [cardsInPlay replaceObjectAtIndex: 14 withObject: [cardsInPlay objectAtIndex :cardAt]];
        [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];

    }
    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"gascan"] ){
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"nogas"] ){
            // if they are currently waiting for a spare, we give them a green light at this point
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 11 withObject: newGreenLight];
            coupFourre++;
            if ( playSounds )
                [cheers play];
        }
        if ( playSounds )
            [getSpecial play];
        numberOfSafetys++;
        gotSpecialBool = YES;
        [cardsInPlay replaceObjectAtIndex: 15 withObject: [cardsInPlay objectAtIndex :cardAt]];
        [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];

    }
    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"racecartraining"] ){
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"accident"] ){
            // if they are currently waiting for a spare, we give them a green light at this point
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 11 withObject: newGreenLight];
            if ( [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"accident"] )
                coupFourre++;
            // increment score !!!!!
            if ( playSounds )
                [cheers play];
        }
        if ( playSounds )
            [getSpecial play];
        gotSpecialBool = YES;
        numberOfSafetys++;
        [cardsInPlay replaceObjectAtIndex: 16 withObject: [cardsInPlay objectAtIndex :cardAt]];
        [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];

    }
    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] < 0 && ![[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo: @"speedlimit"]){
        // I'm trying to hazard my opponent. First, let's see if I can actually do so!
        if ( ![[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"greenlight"] ){
            [statusText setString :NSLocalizedStringFromTable(@"mustbemoving", @"localizedStrings", @"This is the message that your opponent must be moving to hazard")];
            return;
        }
        if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"flat tire"] && [[[cardsInPlay objectAtIndex: 17] objectForKey :@"Name"] isEqualTo :@"driveaircar"]){
            [statusText setString :NSLocalizedStringFromTable(@"protectedFlat", @"localizedStrings", @"This is the message that your opponent is protected against flat tires")];
            return;
        }
        if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"redlight"] && [[[cardsInPlay objectAtIndex: 18] objectForKey :@"Name"] isEqualTo :@"driveambulance"]){
            [statusText setString :NSLocalizedStringFromTable(@"protectedRedLimit", @"localizedStrings", @"This is the message that your opponent is protected against limits and red lights")];
            return;
        }
        if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"nogas"] && [[[cardsInPlay objectAtIndex: 19] objectForKey :@"Name"] isEqualTo :@"gascan"]){
            [statusText setString :NSLocalizedStringFromTable(@"protectedGas", @"localizedStrings", @"This is the message that your opponent is protected against no gas")];
            return;
        }
        if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"accident"] && [[[cardsInPlay objectAtIndex: 20] objectForKey :@"Name"] isEqualTo :@"racecartraining"]){
            [statusText setString :NSLocalizedStringFromTable(@"protectedAccident", @"localizedStrings", @"This is the message that your opponent is protected against accident")];
            return;
        }
        //he doesn't!
        [cardsInPlay replaceObjectAtIndex: 12 withObject: [cardsInPlay objectAtIndex :cardAt]];
        [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        
    }
    // though you are supposed to be able to play a speed limit at any time, so let's do that
    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] == -5 ){
        if (  [[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"] ){
            [statusText setString :NSLocalizedStringFromTable(@"alreadylimited", @"localizedStrings", @"This is the message that your opponent is already limited")];
            return;
        }
        else{
            if ( [[[cardsInPlay objectAtIndex: 18] objectForKey :@"Name"] isEqualTo :@"driveambulance"]){
                // except of course, when you can't.
                [statusText setString :NSLocalizedStringFromTable(@"protectedRedLimit", @"localizedStrings", @"This is the message that your opponent is protected against limits and red lights")];
                return;
            }
            else {
                [cardsInPlay replaceObjectAtIndex: 10 withObject: [cardsInPlay objectAtIndex :cardAt]];
                [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
                [cards removeObjectAtIndex: 0];
            }
        }
    }
    
    else if (  [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"gasstation"] ){
        // I want to try and remove the nogas hazard. First, check to see if I am hazarded
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"nogas"] ){
            [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardAt]];
            [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
        }
        else {
            [statusText setString :NSLocalizedStringFromTable(@"onlynogas", @"localizedStrings", @"This is the message that only gas stations can fix nogas")];
            return;
        }
    }
    else if (  [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"sparetire"] ){
        // I want to try and remove the nogas hazard. First, check to see if I am hazarded
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"flat tire"] ){
            [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardAt]];
            [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
        }
        else {
            [statusText setString :NSLocalizedStringFromTable(@"onlyaflat", @"localizedStrings", @"This is the message that only a tire can fix a flat")];
            return;
        }
    }
    else if (  [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"mechanic"] ){
        // I want to try and remove the nogas hazard. First, check to see if I am hazarded
        if ( [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"accident"] ){
            [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardAt]];
            [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
        }
        else {
            [statusText setString :NSLocalizedStringFromTable(@"onlyaccident", @"localizedStrings", @"This is the message that only a mechanic can fix an accident")];
            return;
        }
    }
    else if (  [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"endspeedlimit"] ){
        // I want to try and remove the nogas hazard. First, check to see if I am hazarded
        if ( [[[cardsInPlay objectAtIndex: 9] objectForKey :@"Name"] isEqualTo :@"speedlimit"] ){
            [cardsInPlay replaceObjectAtIndex: 9 withObject: [cardsInPlay objectAtIndex :cardAt]];
            [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
        }
        else {
            [statusText setString :NSLocalizedStringFromTable(@"onlyspeed", @"localizedStrings", @"This is the message that only a no speed limit can fix speed limit")];
            return;
        }
    }
    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] >= 75 && [[[cardsInPlay objectAtIndex: 9] objectForKey :@"Name"] isEqualTo :@"speedlimit"] ){
        [statusText setString :NSLocalizedStringFromTable(@"toofast", @"localizedStrings", @"This is the message that you are trying to move too fast")];
              return;
        }

    else if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] >= 25 ){
        if (numberOf200s == 2 && [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] == 200 ){
            [statusText setString :NSLocalizedStringFromTable(@"onlytwo", @"localizedStrings", @"This is the message that you can only have 2 200s")];
            return;
        }
        if ( ![[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"greenlight"] ){
            [statusText setString :NSLocalizedStringFromTable(@"needagreen", @"localizedStrings", @"This is the message that you need a green light to move")];
            return;
        }
        else {
    // figure out where it needs to go based on how many of this size have come before
            if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] + currentDistance > currentDistanceGoal ){
                [statusText setString :[NSString stringWithFormat :@"%@%d", NSLocalizedStringFromTable(@"toofar", @"localizedStrings", @"This is the message that your distance is too great"), currentDistanceGoal - currentDistance]];
                return;
            }
            else {
                [playingArea lockFocus];
                if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] == 25 ){
                    [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"]] compositeToPoint:NSMakePoint( 29, 255 - (numberOf25s * 15))
                                                                                                        fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                        operation:NSCompositeSourceOver];
                    numberOf25s++;
                    currentDistance += 25;
                    [myProgressText setString :[NSString stringWithFormat :@"%d", currentDistance]];
                }
                if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] == 50 ){
                    [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"]] compositeToPoint:NSMakePoint( 69, 255 - (numberOf50s * 15))
                                                                                                                                fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                                                operation:NSCompositeSourceOver];
                    numberOf50s++;
                    currentDistance += 50;
                    [myProgressText setString :[NSString stringWithFormat :@"%d", currentDistance]];
                }
                if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] == 75 ){
                    [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"]] compositeToPoint:NSMakePoint( 114, 255 - (numberOf75s * 15))
                                                                                                                                fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                                                operation:NSCompositeSourceOver];
                    numberOf75s++;
                    currentDistance += 75;
                    [myProgressText setString :[NSString stringWithFormat :@"%d", currentDistance]];
                }
                if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] == 100 ){
                    [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"]] compositeToPoint:NSMakePoint( 158, 255 - (numberOf100s * 15))
                                                                                                                                fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                                                operation:NSCompositeSourceOver];
                    numberOf100s++;
                    currentDistance += 100;
                    [myProgressText setString :[NSString stringWithFormat :@"%d", currentDistance]];
                }
                if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue] == 200 ){
                    [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"]] compositeToPoint:NSMakePoint( 201, 255 - (numberOf200s * 100))
                                                                                                                                fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                                                operation:NSCompositeSourceOver];
                    numberOf200s++;
                    currentDistance += 200;
                    [myProgressText setString :[NSString stringWithFormat :@"%d", currentDistance]];
                }
                [playingArea unlockFocus];
            }
//            NSLog ([[cards objectAtIndex :0] description]);
            [[self window] incrementMyProgress :[[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Number"] intValue]];
            [cardsInPlay replaceObjectAtIndex: cardAt withObject: [cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
        }
    }
    if ( [[[cardsInPlay objectAtIndex: cardAt] objectForKey :@"Name"] isEqualTo :@"empty"] )
        emptyCardsPlayed++;
    if ( [[[cardsInPlay objectAtIndex: 14] objectForKey :@"Name"] isEqualTo :@"driveambulance"] && [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Number"] intValue] >= 0){
            // No matter what, if you have an ambulance, you get a green light
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 11 withObject: newGreenLight];
            // increment score !!!!!
        }

    if ( currentDistance == 700 && !askedToExtend && currentDistanceGoal == 700){
        if ( playSounds )
            [extendQuestion play];
        NSBeginAlertSheet(@"Congratulations", @"Yes", nil, @"No", [self window], self, @selector(gatherAnswer:returnCode:contextInfo:), NULL, NULL, NSLocalizedStringFromTable(@"extendrace", @"localizedStrings", @"This is the message asking if you want to extend the race"));
        if ( currentDistance == 700 ){ // remember, it blows right past this....
            [self refreshDeck];
            [self setNeedsDisplay: YES];
            return; // I don't want this coming back to try and offer my opponent one last move... after the
            // race is over. I'll do that if I say YEs to this question
        }
        
        // else do nothing, fall out of here so I actually play the card I tried to...
    }
    if ( currentDistance == 1000 ){
        if ( playSounds )
            [shift play];
        [self finalScoreAndReset];
        return; // I don't need to play the card, do I....? Have to see what the scoreing turns up !!!!!
    }
    
        // if the deck is empty, I don't want to start getting exceptions if I try to replace with nothing
    if ( !gotSpecialBool ){ // don't bother playing another sound
        if ( playSounds )
            [dealCard play];
        [self refreshDeck];
        [self computersTurn]; // if I did get a special, I get another turn, so don't let the computer have one
        [self refreshDeck]; // just in case
        if ( [[[cardsInPlay objectAtIndex: 18] objectForKey :@"Name"] isEqualTo :@"driveambulance"] && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Number"] intValue] >= 0){
            // No matter what, if you have an ambulance, you get a green light
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 12 withObject: newGreenLight];
        }
        while ( opponentPlayedSpecial == YES ){
            // darn it, they get a free turn.
            [self refreshDeck]; // just in case
            [self computersTurn];
            [self refreshDeck];
            opponentPlayedSpecial = NO;
        }
        if ( opponentDistance == 700 && currentDistanceGoal == 700 && currentDistance <= 400 ){
            [extendsRound play];
            extensionByOpponent = 1;
            NSRunAlertPanel(@"Extention",NSLocalizedStringFromTable(@"extend", @"localizedStrings", @"This is the extend the race string") ,@"OK",NULL,NULL);
            currentDistanceGoal = 1000;
        }
        if ( opponentDistance == 700 && currentDistanceGoal == 700 && currentDistance > 400 ){
            [self finalScoreAndReset]; // I win
        }
        if ( opponentDistance == 1000 && currentDistanceGoal == 1000 )
            [self finalScoreAndReset]; // I win, again
    }
    [self refreshDeck];    
    [self setNeedsDisplay: YES];
//    NSLog (@"empty cards played == %d", emptyCardsPlayed);
    while ( emptyCardsPlayed == 7 ){ // when I'm done, this will be 0 again, so I'll break out
        [self refreshDeck];
        [self computersTurn];
        [self refreshDeck];
    }
}

-(void) gatherAnswer:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo
{
    askedToExtend = YES;
    if (returnCode == NSAlertOtherReturn)
        [self finalScoreAndReset]; // get score
    else{
        if ( playSounds )
            [extendsRound play];
        extensionByMe = 1;
        currentDistanceGoal = 1000;
        [self refreshDeck];
        [self computersTurn]; // if I did get a special, I get another turn, so don't let the computer have one
        [self refreshDeck];
        if ( [[[cardsInPlay objectAtIndex: 18] objectForKey :@"Name"] isEqualTo :@"driveambulance"] && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Number"] intValue] >= 0){
            // No matter what, if you have an ambulance, you get a green light
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 12 withObject: newGreenLight];
        }
        while ( opponentPlayedSpecial == YES ){
            // darn it, they get a free turn.
            [self refreshDeck]; // just in case
            [self computersTurn];
            [self refreshDeck];
            opponentPlayedSpecial = NO;
        }
        [self setNeedsDisplay :YES];
    }
}

- (void) refreshDeck
{
//    NSLog (@"RefreshDeck");
    if ( [cards count] == 0 ){
        NSMutableDictionary *nextEmptyCard = [NSMutableDictionary dictionaryWithCapacity: 2];
        NSMutableDictionary *anothertEmptyCard = [NSMutableDictionary dictionaryWithCapacity: 2];
//        NSLog (@"deck needed a refresh!!!!!");
        [nextEmptyCard setObject:@"empty" forKey:@"Name"];
        [nextEmptyCard setObject:@"0" forKey:@"Number"];
        [cards addObject :nextEmptyCard]; // first, put in empty cards so we fill the spaces up
        [anothertEmptyCard setObject:@"empty" forKey:@"Name"];
        [anothertEmptyCard setObject:@"0" forKey:@"Number"];
        [cards addObject :anothertEmptyCard]; // first, put in empty cards so we fill the spaces up
        
    }
}

- (void) finalScoreAndReset
{
    int lcv;
    NSMutableString *scoreString = [[NSMutableString alloc] initWithCapacity :20];
    handScore = 0;
    handScoreO = 0;
    handScore += currentDistance;
    handScoreO += opponentDistance;
    handScore += numberOfSafetys * 100;
    handScoreO += numberOfSafetysO * 100;
    
    [self refreshDeck]; // because I use [cards objectAtIndex: 0] here, so I want to be sure it's not empty *****
    
    [scoreString appendFormat :@"                                 You          Opponent\nMiles Completed          %d               %d\nEach Safety Played        %d                %d\nAll Four Safeties           ", currentDistance, opponentDistance, numberOfSafetys * 100, numberOfSafetysO * 100];
    if ( numberOfSafetys == 4 ){
        handScore += 300;
        [scoreString appendString :@"300             "];
    }
    else 
        [scoreString appendString :@"0               "];
    if ( numberOfSafetysO == 4 ) {
        handScoreO += 300;
        [scoreString appendString :@"300\n"];
    }
    else
        [scoreString appendString :@"0\n"];

    handScore += coupFourre * 300;
    handScoreO += coupFourreO * 300;
    [scoreString appendFormat :@"Each Coup-Fourr        %d                %d\n1000 Completed            ", coupFourre * 300, coupFourreO * 300];
    if ( currentDistance == 1000 ){
        handScore += 400;
        [scoreString appendString :@"400             "];
    }
    else
        [scoreString appendString :@"0               "];
    if ( opponentDistance == 1000 ) {
        handScoreO += 400;
        [scoreString appendString :@"400\n"];
    }
    else
        [scoreString appendString :@"0\n"];
    
    [scoreString appendString :@"Delayed Action             "];
    if ( currentDistance == currentDistanceGoal && [[[cards objectAtIndex: 0] objectForKey :@"Name"] isEqualTo :@"empty"]){
        handScore += 300;
        [scoreString appendString :@"300             "];
    }
    else
        [scoreString appendString :@"0               "];
    if ( opponentDistance == currentDistanceGoal && [[[cards objectAtIndex: 0] objectForKey :@"Name"] isEqualTo :@"empty"]){
        [scoreString appendString :@"300\n"];
        handScoreO += 300;
    }
    else
        [scoreString appendString :@"0\n"];

    [scoreString appendString :@"Safe Trip                      "];
    if ( currentDistance == currentDistanceGoal && numberOf200s == 0){
        handScore += 200;
        [scoreString appendString :@"200             "];
    }
    else
        [scoreString appendString :@"0               "];
    if ( opponentDistance == currentDistanceGoal && numberOf200sO == 0){
        handScoreO += 200;
        [scoreString appendString :@"200\n"];
    }
    else
        [scoreString appendString :@"0\n"];

    [scoreString appendString :@"Extension                     "];
    if ( currentDistance == currentDistanceGoal && extensionByMe == 1){
        handScore += 200;
        [scoreString appendString :@"200             "];
    }
    else
        [scoreString appendString :@"0               "];
    if ( opponentDistance == currentDistanceGoal && extensionByOpponent == 1){
        handScoreO += 200;
        [scoreString appendString :@"200\n"];
    }
    else
        [scoreString appendString :@"0\n"];

    [scoreString appendString :@"Shut-Out                     "];
    if (  numberOf25sO == 0 && numberOf50sO == 0 && numberOf75sO == 0 && numberOf100sO == 0 && numberOf200sO == 0 && currentDistance == currentDistanceGoal){
        handScore += 500;
        [scoreString appendString :@"500             "];
    }
    else
        [scoreString appendString :@"0               "];
    if ( numberOf25s == 0 && numberOf50s == 0 && numberOf75s == 0 && numberOf100s == 0 && numberOf200s == 0 && opponentDistance == currentDistanceGoal){
        handScoreO += 500;
        [scoreString appendString :@"500\n\n"];
    }
    else
        [scoreString appendString :@"0\n\n"];

//    NSLog (@"Score anyway is %d", scoreAnyway);
    if ( scoreAnyway == 0 ){ // just skip it if I'm supposed to do it anyway
        if ( currentDistance != currentDistanceGoal && opponentDistance != currentDistanceGoal ){
            handScore = 0;
            handScoreO = 0;
        }
    }
    
    [scoreString appendFormat :@"Hand Totals                   %d                    %d\n", handScore, handScoreO];
    endScore += handScore;
    endScoreO += handScoreO;
    [scoreString appendFormat :@"Game Total                    %d                    %d\n", endScore, endScoreO];

    if ( endScore > endScoreO && endScore > 5000 )
        gamesWon++;
    if ( endScoreO > endScore && endScoreO > 5000 )
        gamesWonO++;
    [scoreString appendFormat :@"Games Won                   %d                    %d\n", gamesWon, gamesWonO];
    
    if ( (endScore > endScoreO && endScore > 5000) || ( endScoreO > endScore && endScoreO > 5000 ) ){
        endScore = 0;
        endScoreO = 0;
    }
    
    
    NSRunAlertPanel (@"Score", scoreString ,@"OK",NULL,NULL);

    askedToExtend = NO;
    [[self window] incrementMyProgress :-currentDistance];
    [[self window] incrementOpponentProgress :-opponentDistance];
    [myProgressText setString :@"0"];
    [opponentProgressText setString: @"0"];
    otherMouseButtonDownCounter = 0;
    clickCardTransparency = 100;
    transparencyDirection = -20;
    clickNumber = 0;
    numberOf25s = 0;
    numberOf50s = 0;
    numberOf75s = 0;
    numberOf100s = 0;
    numberOf200s = 0;
    numberOf25sO = 0;
    numberOf50sO = 0;
    numberOf75sO = 0;
    numberOf100sO = 0;
    numberOf200sO = 0;    
    currentDistanceGoal = 700;
    scoreAnyway = 0;
    coupFourre = 0;
    coupFourreO = 0;
    currentDistance = 0;
    opponentDistance = 0;
    numberOfSafetys = 0;
    numberOfSafetysO = 0;
    emptyCardsPlayed = 0;
    extensionByMe = 0;
    extensionByOpponent = 0;
    askedToExtend = NO;
    gotSpecialBool = NO;
    opponentPlayedSpecial = NO;
    [cards removeAllObjects];
    [cardsInPlay removeAllObjects];
    for ( lcv = 0; lcv < 28; lcv++){
        NSMutableDictionary *nextEmptyCard = [NSMutableDictionary dictionaryWithCapacity: 2];
        [nextEmptyCard setObject:@"empty" forKey:@"Name"];
        [nextEmptyCard setObject:@"0" forKey:@"Number"];
        [cardsInPlay addObject :nextEmptyCard]; // first, put in empty cards so we fill the spaces up
    }
    [playingArea lockFocus];
    [[NSColor clearColor] set];
    NSRectFill( NSMakeRect( 0,0, 800, 600));
    [cardbackToDeal compositeToPoint:NSMakePoint(618, 14)
                            fromRect:NSMakeRect(0, 0, 80, 100)
                            operation:NSCompositeSourceOver];

    for ( lcv = 0; lcv < 28; lcv++ )
        [[NSImage imageNamed:[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Name"]] compositeToPoint:cardSlots[lcv]
                                                                                               fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                              operation:NSCompositeSourceOver];

    for ( lcv = 0; lcv < 16; lcv++ )
        [self removeTrackingRect: trackingRectCard[lcv]];
    
    [self lockFocus];
    [playingArea compositeToPoint:NSMakePoint(0, 0)
                         fromRect:NSMakeRect(0, 0, 800, 600)
                        operation:NSCompositeSourceOver];

    [self unlockFocus];
    [[self window] flushWindow];
    
    // this will wipe the board clean

    state = noCardsDelt;
    [self setNeedsDisplay: YES]; // this'll start the click thing flashing
    if ( playSounds == YES )
        [shuffle play];
    [self setTimer :.3];

}

- (void) deleteCard
{
    [statusText setString :@" "];
    if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"empty"] )
        return;
        // don't bother doing something with that card if it's empty
    if ( clickedCard < 7 && clickedCard > -1 ){
        if ( !gotSpecialBool ) // don't bother playing another sound
            if ( playSounds )
                [dealCard play];
        //        NSLog ([[cards objectAtIndex :0] description]);
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex: clickedCard]];
        [cardsInPlay replaceObjectAtIndex: clickedCard withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        if ( [[[cardsInPlay objectAtIndex: clickedCard] objectForKey :@"Name"] isEqualTo :@"empty"] )
            emptyCardsPlayed++;

        [self refreshDeck];
        [self setNeedsDisplay: YES]; // Actually I'll animate this too....
        if ( ![getSpecial isPlaying] ) // don't bother playing another sound
            if ( [dealCard isPlaying] ) // however, play all of these, so wait until it's done
                [NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:.5]];
        [self computersTurn];
        [self refreshDeck];
        if ( [[[cardsInPlay objectAtIndex: 18] objectForKey :@"Name"] isEqualTo :@"driveambulance"] && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Number"] intValue] >= 0){
            // No matter what, if you have an ambulance, you get a green light
            NSMutableDictionary *newGreenLight = [NSMutableDictionary dictionaryWithCapacity: 2];
            [newGreenLight setObject:@"greenlight" forKey:@"Name"];
            [newGreenLight setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 12 withObject: newGreenLight];
            // increment score !!!!!
        }
        while ( opponentPlayedSpecial == YES ){
            // darn it, they get a free turn.
            [self refreshDeck]; // just in case
            [self computersTurn];
            opponentPlayedSpecial = NO;
            [self refreshDeck];
        }
        if ( opponentDistance == 700 && currentDistanceGoal == 700 && currentDistance < 400 ){
            [extendsRound play];
            extensionByOpponent = 1;
            NSRunAlertPanel(@"Extention",NSLocalizedStringFromTable(@"extend", @"localizedStrings", @"This is the extend the race string") ,@"OK",NULL,NULL);
            currentDistanceGoal = 1000;
        }
        if ( opponentDistance == 700 && currentDistanceGoal == 700 && currentDistance > 400 ){
            [self finalScoreAndReset]; // I win
        }
        if ( opponentDistance == 1000 && currentDistanceGoal == 1000 )
            [self finalScoreAndReset]; // I win, again
    
        [self refreshDeck];
//        NSLog (@"empty cards played 2 is %d", emptyCardsPlayed);
        while ( emptyCardsPlayed == 7 ){ // when I'm done, this will be 0 again, so I'll break out
            [self refreshDeck];
            [self computersTurn];
            [self refreshDeck];
        }
    }
    
}

- (void) computersTurn
{
    // as you can see, I return after each of these. So really, the order is sort ofa preference. I think
    // a red light is more important then just a speed limiter to play, so I look for that first, then the
    // limiter. Got that?
    
    NSMutableDictionary *dummyCard = [NSMutableDictionary dictionaryWithCapacity: 2];
//    NSLog (@"computers turn");
    [dummyCard setObject:@"greenlight" forKey:@"Name"];
    [dummyCard setObject:@"2" forKey:@"Number"];
    int cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    // If I have one, (and I don't already have one in play, and I can ) or I have a red light
    if ( (cardLookingFor != NSNotFound && ![[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"greenlight"] && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Number"] intValue] >= 0) || ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"redlight"])){
        [cardsInPlay replaceObjectAtIndex: 12 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"redlight" forKey:@"Name"];
    [dummyCard setObject:@"-2" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ![[[cardsInPlay objectAtIndex: 14] objectForKey :@"Name"] isEqualTo :@"driveambulance"] && [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"greenlight"]){
        // if I've found it and I'm not protected against it and I have a green light so I can play it
        [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    // I could even do a "difficulty level" here. On medium I know what's in your hand, so I play something you don't have a solution to.
    // on "hard" I would not only know what's in your hand, I would rifle through the deck and find out what card you'll be getting soon, so you are guarenteed not to get a solution...
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"speedlimit" forKey:@"Name"];
    [dummyCard setObject:@"-5" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ![[[cardsInPlay objectAtIndex: 14] objectForKey :@"Name"] isEqualTo :@"driveambulance"] && ![[[cardsInPlay objectAtIndex: 9] objectForKey :@"Name"] isEqualTo :@"speedlimit"]){ // if I've found it and I'm not protected against it, and I don't already see one there
        [cardsInPlay replaceObjectAtIndex: 9 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"flat tire" forKey:@"Name"];
    [dummyCard setObject:@"-1" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ![[[cardsInPlay objectAtIndex: 13] objectForKey :@"Name"] isEqualTo :@"driveaircar"] && [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"greenlight"]){ // if I've found it and he's not protected against it and he has a green light
        [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"accident" forKey:@"Name"];
    [dummyCard setObject:@"-4" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ![[[cardsInPlay objectAtIndex: 16] objectForKey :@"Name"] isEqualTo :@"racecartraining"] && [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"greenlight"]){ // if I've found it and he's not protected against it and he has a green light
        [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"nogas" forKey:@"Name"];
    [dummyCard setObject:@"-3" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ![[[cardsInPlay objectAtIndex: 15] objectForKey :@"Name"] isEqualTo :@"gascan"] && [[[cardsInPlay objectAtIndex: 11] objectForKey :@"Name"] isEqualTo :@"greenlight"]){ // if I've found it and he's not protected against it and he has a green light
        [cardsInPlay replaceObjectAtIndex: 11 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"endspeedlimit" forKey:@"Name"];
    [dummyCard setObject:@"5" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"] ){ // get rid of the speed limit
        [cardsInPlay replaceObjectAtIndex: 10 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"driveaircar" forKey:@"Name"];
    [dummyCard setObject:@"1" forKey:@"Number"];
    [dummyCard setObject:@"1" forKey:@"Special"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
        //     NSLog (@"%d", cardLookingFor );
    if ( cardLookingFor != NSNotFound && ([[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"flat tire"]
         || currentDistance + 50 >= currentDistanceGoal || opponentDistance + 50 >= currentDistanceGoal)){
        [cardsInPlay replaceObjectAtIndex: 17 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        if ( [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"flat tire"] ) {
            [dummyCard removeAllObjects];
            [dummyCard setObject:@"greenlight" forKey:@"Name"];
            [dummyCard setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 12 withObject: dummyCard];
            coupFourreO++;
        }
        opponentPlayedSpecial = YES;
        numberOfSafetysO++;
        return;
    }
    //     NSLog (@"2");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"driveambulance" forKey:@"Name"];
    [dummyCard setObject:@"2" forKey:@"Number"];
    [dummyCard setObject:@"1" forKey:@"Special"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && (([[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"redlight"] || [[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"])
        || currentDistance + 50 >= currentDistanceGoal || opponentDistance + 50 >= currentDistanceGoal)){
            [cardsInPlay replaceObjectAtIndex: 18 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
            [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
        if ( [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"redlight"] ){
            [dummyCard removeAllObjects];
            [dummyCard setObject:@"greenlight" forKey:@"Name"];
            [dummyCard setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 12 withObject: dummyCard];
            coupFourreO++;
        }
        if ( [[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"] ){
            [dummyCard removeAllObjects];
            [dummyCard setObject:@"endspeedlimit" forKey:@"Name"];
            [dummyCard setObject:@"5" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 10 withObject: dummyCard];
            opponentPlayedSpecial = YES;
            coupFourreO++;
        }
        numberOfSafetysO++;
        return;
    }
    //     NSLog (@"3");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"gascan" forKey:@"Name"];
    [dummyCard setObject:@"3" forKey:@"Number"];
    [dummyCard setObject:@"1" forKey:@"Special"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ([[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"nogas"]
         || currentDistance + 50 >= currentDistanceGoal || opponentDistance + 50 >= currentDistanceGoal)){
        [cardsInPlay replaceObjectAtIndex: 19 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        if ( [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"nogas"] ){
            [dummyCard removeAllObjects];
            [dummyCard setObject:@"greenlight" forKey:@"Name"];
            [dummyCard setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 12 withObject: dummyCard];
            coupFourreO++;
        }
        opponentPlayedSpecial = YES;
        numberOfSafetysO++;
            

        return;
    }
    //     NSLog (@"4");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"racecartraining" forKey:@"Name"];
    [dummyCard setObject:@"4" forKey:@"Number"];
    [dummyCard setObject:@"1" forKey:@"Special"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ([[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"accident"]
         || currentDistance + 50 >= currentDistanceGoal || opponentDistance + 50 >= currentDistanceGoal)){
        [cardsInPlay replaceObjectAtIndex: 20 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        if ( [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"accident"] ){
            [dummyCard removeAllObjects];
            [dummyCard setObject:@"greenlight" forKey:@"Name"];
            [dummyCard setObject:@"2" forKey:@"Number"];
            [cardsInPlay replaceObjectAtIndex: 12 withObject: dummyCard];
            coupFourreO++;
        }
        opponentPlayedSpecial = YES;
        numberOfSafetysO++;
        return;
    }
    //     NSLog (@"5");
    // now that he's wacked me with whatever, let's see if the plank in his own eye needs tending
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"sparetire" forKey:@"Name"];
    [dummyCard setObject:@"1" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"flat tire"] ){
        [cardsInPlay replaceObjectAtIndex: 12 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    //     NSLog (@"6");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"mechanic" forKey:@"Name"];
    [dummyCard setObject:@"4" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"accident"] ){
        [cardsInPlay replaceObjectAtIndex: 12 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    //     NSLog (@"7");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"gasstation" forKey:@"Name"];
    [dummyCard setObject:@"3" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"nogas"] ){
        [cardsInPlay replaceObjectAtIndex: 12 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    //     NSLog (@"8");
    // now that he can't play anything against me, and he has nothing to fix, let him try to move
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"200miles" forKey:@"Name"];
    [dummyCard setObject:@"200" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"greenlight"] && ![[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"] && numberOf200sO < 2 && 200 + opponentDistance <= currentDistanceGoal){
        [playingArea lockFocus];
        [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Name"]] 							compositeToPoint:NSMakePoint( 605, 245 - (numberOf200sO * 100))
                                        fromRect:NSMakeRect(0, 0, 80, 100)
                                        operation:NSCompositeSourceOver];
        numberOf200sO++;
        opponentDistance += 200;
        [opponentProgressText setString :[NSString stringWithFormat :@"%d", opponentDistance]];

        [playingArea unlockFocus];
        [[self window] incrementOpponentProgress :[[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Number"] intValue]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    //     NSLog (@"9");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"100miles" forKey:@"Name"];
    [dummyCard setObject:@"100" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"greenlight"] && ![[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"] && 100 + opponentDistance <= currentDistanceGoal ){
        [playingArea lockFocus];
        [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Name"]] compositeToPoint:NSMakePoint( 562, 245 - (numberOf100sO * 15)) fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                        operation:NSCompositeSourceOver];
        numberOf100sO++;
        opponentDistance += 100;
        [opponentProgressText setString :[NSString stringWithFormat :@"%d", opponentDistance]];

        [playingArea unlockFocus];
        [[self window] incrementOpponentProgress :[[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Number"] intValue]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    //     NSLog (@"10");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"75miles" forKey:@"Name"];
    [dummyCard setObject:@"75" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"greenlight"] && ![[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"] && 75 + opponentDistance <= currentDistanceGoal){
        [playingArea lockFocus];
        [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Name"]] 							compositeToPoint:NSMakePoint( 519, 245 - (numberOf75sO * 15))
                                                                                                         fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                        operation:NSCompositeSourceOver];
        numberOf75sO++;
        opponentDistance += 75;
        [opponentProgressText setString :[NSString stringWithFormat :@"%d", opponentDistance]];

        [playingArea unlockFocus];
        [[self window] incrementOpponentProgress :[[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Number"] intValue]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    //     NSLog (@"11");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"50miles" forKey:@"Name"];
    [dummyCard setObject:@"50" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"greenlight"] && 50 + opponentDistance <= currentDistanceGoal){
        [playingArea lockFocus];
        [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Name"]] 							compositeToPoint:NSMakePoint( 476, 245 - (numberOf50sO * 15))
                                                                                                        fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                        operation:NSCompositeSourceOver];
        numberOf50sO++;
        opponentDistance += 50;
        [opponentProgressText setString :[NSString stringWithFormat :@"%d", opponentDistance]];
    
        [playingArea unlockFocus];
        [[self window] incrementOpponentProgress :[[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Number"] intValue]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        return;
    }
    //     NSLog (@"12");
[dummyCard removeAllObjects];
[dummyCard setObject:@"25miles" forKey:@"Name"];
[dummyCard setObject:@"25" forKey:@"Number"];
cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 12] objectForKey :@"Name"] isEqualTo :@"greenlight"]){
    [playingArea lockFocus];
    [[NSImage imageNamed:[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Name"]] 							compositeToPoint:NSMakePoint( 433, 245 - (numberOf25sO * 15))
                                                                                                     fromRect:NSMakeRect(0, 0, 80, 100)
                                                                                                    operation:NSCompositeSourceOver];
    numberOf25sO++;
    opponentDistance += 25;
    [opponentProgressText setString :[NSString stringWithFormat :@"%d", opponentDistance]];

    [playingArea unlockFocus];
    [[self window] incrementOpponentProgress :[[[cardsInPlay objectAtIndex: cardLookingFor] objectForKey :@"Number"] intValue]];
    [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
    [cards removeObjectAtIndex: 0];
    return;
}
//     NSLog (@"13");
// ok, so he can't move, or give me anything, so he'll just have to discard. Let's teach him how!
[self refreshDeck];
[self computerDiscard];
[self refreshDeck];
[self setNeedsDisplay: YES]; // Actually I'll animate this too....

}

- (void) computerDiscard
{
    int lcv, lcv2;
    int lookingForTemp;
    // first, get rid of the most useless card, a fix for something I'm immune, or can be immune, to, or that my oppononet is immune to
    NSMutableDictionary *dummyCard = [NSMutableDictionary dictionaryWithCapacity: 2];
    NSMutableDictionary *dummyCard2 = [NSMutableDictionary dictionaryWithCapacity: 2];
    int cardLookingFor, cardLookingFor2;
    //     NSLog (@"looking to discard");
    [dummyCard setObject:@"gasstation" forKey:@"Name"];
    [dummyCard setObject:@"3" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    [dummyCard2 setObject:@"gascan" forKey:@"Name"];
    [dummyCard2 setObject:@"3" forKey:@"Number"];
    [dummyCard2 setObject:@"1" forKey:@"Special"];
    cardLookingFor2 = [cardsInPlay indexOfObject: dummyCard2 inRange:NSMakeRange(21, 7)];
    if ( (cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 19] objectForKey :@"Name"] isEqualTo :@"gascan"] ) || ( cardLookingFor2 != NSNotFound && cardLookingFor != NSNotFound )){
    // my oppononet is immune or I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"Protected by gascan, removed gas station");
        return;
    }
//    NSLog (@"2");
    [dummyCard removeAllObjects];
    [dummyCard2 removeAllObjects];
    [dummyCard setObject:@"mechanic" forKey:@"Name"];
    [dummyCard setObject:@"4" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    [dummyCard2 setObject:@"racecartraining" forKey:@"Name"];
    [dummyCard2 setObject:@"4" forKey:@"Number"];
    [dummyCard2 setObject:@"1" forKey:@"Special"];
    cardLookingFor2 = [cardsInPlay indexOfObject: dummyCard2 inRange:NSMakeRange(21, 7)];
    if ( (cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 20] objectForKey :@"Name"] isEqualTo :@"racecartraining"] ) || ( cardLookingFor2 != NSNotFound && cardLookingFor != NSNotFound )){
        // I am immune and have a fix in my hand, or I have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
         //     NSLog (@"Protected by racecar, removed mechanic");
        return;
    }
//    NSLog (@"3");
    [dummyCard removeAllObjects];
    [dummyCard2 removeAllObjects];
    [dummyCard setObject:@"sparetire" forKey:@"Name"];
    [dummyCard setObject:@"1" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    [dummyCard2 setObject:@"driveaircar" forKey:@"Name"];
    [dummyCard2 setObject:@"1" forKey:@"Number"];
    [dummyCard2 setObject:@"1" forKey:@"Special"];
    cardLookingFor2 = [cardsInPlay indexOfObject: dummyCard2 inRange:NSMakeRange(21, 7)];
    if ( (cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 17] objectForKey :@"Name"] isEqualTo :@"driveaircar"] ) || ( cardLookingFor2 != NSNotFound && cardLookingFor != NSNotFound )){
        // I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
         //     NSLog (@"Protected by aircar, removed sparetire");
        return;
    }
//    NSLog (@"4");
    [dummyCard removeAllObjects];
    [dummyCard2 removeAllObjects];
    [dummyCard setObject:@"greenlight" forKey:@"Name"];
    [dummyCard setObject:@"2" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    [dummyCard2 setObject:@"driveambulance" forKey:@"Name"];
    [dummyCard2 setObject:@"2" forKey:@"Number"];
    [dummyCard2 setObject:@"1" forKey:@"Special"];
    cardLookingFor2 = [cardsInPlay indexOfObject: dummyCard2 inRange:NSMakeRange(21, 7)];
    if ( (cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 20] objectForKey :@"Name"] isEqualTo :@"driveambulance"] ) || ( cardLookingFor2 != NSNotFound && cardLookingFor != NSNotFound )){
    // I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
         //     NSLog (@"Protected by ambulance, removed greenlight");
        return;
    }
//    NSLog (@"5");
    [dummyCard removeAllObjects];
    [dummyCard2 removeAllObjects];
    [dummyCard setObject:@"endspeedlimit" forKey:@"Name"];
    [dummyCard setObject:@"5" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    [dummyCard2 setObject:@"driveambulance" forKey:@"Name"];
    [dummyCard2 setObject:@"2" forKey:@"Number"];
    [dummyCard2 setObject:@"1" forKey:@"Special"];
    cardLookingFor2 = [cardsInPlay indexOfObject: dummyCard2 inRange:NSMakeRange(21, 7)];
    if ( (cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 20] objectForKey :@"Name"] isEqualTo :@"driveambulance"] ) || ( cardLookingFor2 != NSNotFound && cardLookingFor != NSNotFound )){
        // I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"Protected by ambulance, removed speedlimit");
        return;
    }
//NSLog (@"6");
    // next useless is having a limiter to give to my opponent, but he's immune.
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"flat tire" forKey:@"Name"];
    [dummyCard setObject:@"-1" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 13] objectForKey :@"Name"] isEqualTo :@"driveaircar"]){
        // my oppononet is immune or I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"Protected by aircar, removed flattire");
        return;
    }
//    NSLog (@"7");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"redlight" forKey:@"Name"];
    [dummyCard setObject:@"-2" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 14] objectForKey :@"Name"] isEqualTo :@"driveambulance"]){
        // my oppononet is immune or I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"Protected by ambulance, removed redlight");
        return;
    }
//    NSLog (@"8");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"nogas" forKey:@"Name"];
    [dummyCard setObject:@"-3" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 15] objectForKey :@"Name"] isEqualTo :@"gascan"]){
        // my oppononet is immune or I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"Protected by gascan, removed nogas");
        return;
    }    
//       NSLog (@"9");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"accident" forKey:@"Name"];
    [dummyCard setObject:@"-4" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 16] objectForKey :@"Name"] isEqualTo :@"racecartraining"]){
        // my oppononet is immune or I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"Protected by gascan, removed nogas");
        return;
    }
//        NSLog (@"9");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"speedlimit" forKey:@"Name"];
    [dummyCard setObject:@"-5" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && [[[cardsInPlay objectAtIndex: 14] objectForKey :@"Name"] isEqualTo :@"driveambulance"]){
        // my oppononet is immune or I am immune and have a fix in my hand, or I'm have the immunity card, haven't played it, and have a fix
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"Protected by ambulance, removed speedlimit");
        return;
    }
//    NSLog (@"10");
    // next useless is 200s, if you have more then you can possibly use, you pig
    [dummyCard removeAllObjects];
    [dummyCard2 removeAllObjects];
    lookingForTemp = 0;
    [dummyCard setObject:@"200miles" forKey:@"Name"];
    [dummyCard setObject:@"200" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound ){
        // now, see how many I have
        for ( lcv = 21; lcv < 27; lcv++ )
            if ( [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Name"] isEqualTo :@"200miles"] )
                lookingForTemp++;
        if ( lookingForTemp >= 3 || numberOf200sO >= 2){ // I have three and can't use them, or I have one and I've already played two
            [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
            [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
            [cards removeObjectAtIndex: 0];
            //     NSLog (@"too many 200s");
            return;
        }
    }
//    NSLog (@"11");
    // next useless is having a 25, and not being under a limit.
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"25miles" forKey:@"Name"];
    [dummyCard setObject:@"25" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && ![[[cardsInPlay objectAtIndex: 10] objectForKey :@"Name"] isEqualTo :@"speedlimit"]){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 25. Away with the!");
        return;
    }
//    NSLog (@"12");
    // a double for loop, looking for duplicate cards
    for ( lcv = 21; lcv < 27; lcv++ ){
        int numberLookingFor = [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue];
        if ( [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Special"] intValue] != 1 && numberLookingFor < 10){
            // I don't want to remove duplicate distance cards, now do I?
            for ( lcv2 = lcv + 1; lcv2 < 27; lcv2++ ){
                if ( [[[cardsInPlay objectAtIndex: lcv2] objectForKey :@"Number"] intValue] == numberLookingFor && [[[cardsInPlay objectAtIndex: lcv2] objectForKey :@"Number"] intValue] != 0){
 //                   NSLog (@"duplicate %@, %@ card removed", [[cardsInPlay objectAtIndex: lcv] objectForKey :@"Name"], [[cardsInPlay objectAtIndex: lcv2] objectForKey :@"Name"]);
                    // it's a duplicate, remove it, but not if the duplicate is special
                    [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :lcv2]];
                    [cardsInPlay replaceObjectAtIndex: lcv2 withObject: [cards objectAtIndex :0]];
                    [cards removeObjectAtIndex: 0];
                    return;
                }
            }
        }	
    }
//    NSLog (@"13");
    // almost done, but now, if I have a card I don't need, I can get rid of it
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"200miles" forKey:@"Name"];
    [dummyCard setObject:@"200" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 200 > currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 200. Away with the2!");
        return;
    }
//    NSLog (@"14");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"100miles" forKey:@"Name"];
    [dummyCard setObject:@"100" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 100 > currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 100. Away with the2!");
        return;
    }
//    NSLog (@"15");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"75miles" forKey:@"Name"];
    [dummyCard setObject:@"75" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 75 > currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 75. Away with the2!");
        return;
    }
//    NSLog (@"16");
    [dummyCard setObject:@"50miles" forKey:@"Name"];
    [dummyCard setObject:@"50" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 50 > currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 50. Away with the2!");
        return;
    }

    //  get rid of the smallest card I can afford to.
//NSLog (@"17");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"50miles" forKey:@"Name"];
    [dummyCard setObject:@"50" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 50 < currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 50. Away with the!");
        return;
    }
//    NSLog (@"18");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"75miles" forKey:@"Name"];
    [dummyCard setObject:@"75" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 75 < currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 75. Away with the!");
        return;
    }
//    NSLog (@"19");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"100miles" forKey:@"Name"];
    [dummyCard setObject:@"100" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 100 < currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 100. Away with the!");
        return;
    }
//    NSLog (@"20");
    [dummyCard removeAllObjects];
    [dummyCard setObject:@"200miles" forKey:@"Name"];
    [dummyCard setObject:@"200" forKey:@"Number"];
    cardLookingFor = [cardsInPlay indexOfObject: dummyCard inRange:NSMakeRange(21, 7)];
    if ( cardLookingFor != NSNotFound && opponentDistance + 200 < currentDistanceGoal){
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex :cardLookingFor]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
        //     NSLog (@"useless 200. Away with the!");
        return;
    }
//NSLog (@"21");
    // if you get this far, just assign a value to each card, look once through the available one, and pick that one for dismissal.
    cardLookingFor = 0;
    for ( lcv = 21; lcv < 27; lcv++ ){
        if ( [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue] != 0 ){
            cardLookingFor = [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue];
            cardLookingFor2 = lcv;
            lcv = 28;
        }
    }
    for ( lcv = 21; lcv < 27; lcv++ ){
        if ( cardLookingFor > [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue] && [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue] != 0 && lcv != cardLookingFor2){
            cardLookingFor = [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue];
            cardLookingFor2 = lcv;
        }
    }

    if ( cardLookingFor != 0 ){ // if it's still 0, that means I don't have any more to play either
        //     NSLog (@"fallout- lowest card removed");
        [cardsInPlay replaceObjectAtIndex: 8 withObject: [cardsInPlay objectAtIndex: cardLookingFor2]];
        [cardsInPlay replaceObjectAtIndex: cardLookingFor2 withObject: [cards objectAtIndex :0]];
        [cards removeObjectAtIndex: 0];
    }
    if ( cardLookingFor == 0 ){
        cardLookingFor2 = 0;
        for ( lcv = 0; lcv < 7; lcv++ )
            if ( [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue] != 0 )
                cardLookingFor2 = [[[cardsInPlay objectAtIndex: lcv] objectForKey :@"Number"] intValue];
        // so I'll only set card...2 if it's not 0, meaning I do find something, so don't give up on me yet!
    }
    
    if ( cardLookingFor == 0 && cardLookingFor2 == 0 ) {  // No one has any cards to give, darn it! End this!
        scoreAnyway = 1;
        //     NSLog (@"Going to score anyway");
        [self finalScoreAndReset];
    }
}

@end
